﻿/**

*/
module nemuxi.negui.window.mainwindow;

debug import std.stdio: wl = writefln, pl = printf;
debug(mainwindow) void main() {}

import win32.windows;

import nemuxi.base;
public import nemuxi.negui.negui;
public import nemuxi.negui.window.newindow;
public import nemuxi.negui.window.dialog.dialog;

///
class MainWindow: NeWindow {
	invariant() {
		debug assert(One == 1);
	}
	debug int One=0;
	this(GUIINFO* NeGuiInfo) {
		debug One+=1;
		NeGuiInfo.Window    = true;
		super(NeGuiInfo);
	}
	
	private mixin Message;
	
	INT execute() {
		return loop();
	}

	protected override void OnDestroy() {
		super.OnDestroy();
		PostQuitMessage(0);
	}

	private {
		struct WINDOWDATA {
			Window[] windows;
			MainWindow me;
			DWORD ProccessID;
		}
		static extern(Windows) BOOL EnumWindowsProc(HWND hWnd , LPARAM lParam) {
			auto WindowData=cast(WINDOWDATA*)lParam;
			
			DWORD ProccessID;
			GetWindowThreadProcessId(hWnd, &ProccessID);
			if(WindowData.ProccessID != ProccessID) {
				return TRUE;
			} else if((new OtherWindow(hWnd)).className != WindowData.me.className) {
				return TRUE;
			}
			if(auto window=cast(Window)NeGui.getGuiObject(hWnd)) {
				if(window == WindowData.me) {
					return TRUE;
				}
				WindowData.windows ~= window;
			}
			
			return TRUE;
		}
	}
	/**
	History:
		1.00β17:
			新規追加。
	*/
	final Window[] getNeGuiWindow() {
		WINDOWDATA WindowData;
		WindowData.me = this;
		GetWindowThreadProcessId(hWnd, &WindowData.ProccessID);
		EnumWindows(&EnumWindowsProc, cast(LPARAM)&WindowData);

		return WindowData.windows;
	}
}



